function ps2(phi0,theta0,v0,CN)
figure
z0=[0;0;0];  ztarget=[42;5;0];
time=linspace(0,10,70);

drawStart(z0,ztarget)
drawPath(z0,v0,theta0,phi0,time,CN)
    xlabel(" x-axis ")
    ylabel(" y-axis ")
    zlabel(" z-axis ")

end
function drawStart(z0,ztarget)
    [X,Y,Z] = sphere(10);
    r = 1.1;
    surf(r*X+z0(1),r*Y+z0(2),r*Z+z0(3),"FaceColor",[0 1 0],"EdgeColor","none")
    hold on
    [X,Y,Z] = cylinder(3,20);
    surf(ztarget(1)+X,ztarget(2)+Y,ztarget(3)+Z*2,'edgecolor','none','facecolor','red')
    axis equal
    axis([0,50,-25,25,0,40])
    grid on
    set(gca,"Clipping","off")

end

function drawPath(z0,v0,theta,phi,time,CN)
switch CN
    case 0
        xa=z0(1); ya=z0(2); za=z0(3);
        
        vx0=v0*cos(theta).*cos(phi);
        vy0=v0*cos(theta).*sin(phi);
        vz0=v0*sin(theta);
        
        x=@(t)xa+vx0*t;
        y=@(t)ya+vy0*t;
        z=@(t)za+vz0*t-0.5*9.8*t.^2;
        
    case 1
        xa=z0(1); ya=z0(2); za=z0(3)+9.8;
        
        vx0=v0*cos(theta).*cos(phi);
        vy0=v0*cos(theta).*sin(phi);
        vz0=v0*sin(theta);
        
        x=@(t)xa*exp(t);
        y=@(t)ya*exp(t);
        z=@(t)za*exp(t)+9.8;
        
    case 2
        xa=z0(1); ya=z0(2); za=z0(3);
        
        vx0=v0*cos(theta).*cos(phi);
        vy0=v0*cos(theta).*sin(phi);
        vz0=v0*sin(theta);
        
        x=@(t)xa+vx0*t;
        y=@(t)ya+vy0*t;
        z=@(t)za+vz0*t-0.5*9.8*t.^2;
        
    case 3
        xa=z0(1); ya=z0(2); za=z0(3);
        
        vx0=v0*cos(theta).*cos(phi);
        vy0=v0*cos(theta).*sin(phi);
        vz0=v0*sin(theta);
        
        x=@(t)xa+vx0*t;
        y=@(t)ya+vy0*t;
        z=@(t)za+vz0*t+0.5*9.8*t.^2;
        
    otherwise
        x=@(t)0;
        y=@(t)0;
        z=@(t)0;
end
            
        lightangle(0,90)
        [X,Y,Z] = sphere(10); % A sphere to plot

    for tf=time
        ax = gca;
        if(z(tf)<0 || x(tf) > ax.XLim(2) || y(tf) > ax.YLim(2) )
            break % Break if it hits an axis limit
        end
        t=linspace(0,tf);    
        if z(end)>0
        hold on;
        surf(X+x(tf),Y+y(tf),Z+z(tf),"FaceColor",[0.8 0.4 0.4],"EdgeColor","none")
        surf(X+x(tf),Y+y(tf),Z*0,"FaceColor","black","EdgeColor","none")
        hold off
        pause(0.001);
        end
    end
end
